class QuickVote < Election
  after_validation :create_candidates
  validates_uniqueness_of :name
  attr_accessor :raw_candidates
  attr_accessor :reviewed

  def validate
    if @raw_candidates.length < 2
      errors.add("You must list at least two candidates.")
    end

    if name =~ /[^A-Za-z0-9]/
      errors.add("The name must only include numbers and letters.")
    end
  end
  
  def initialize(params={})
    super
    self.enddate =  Time.now + 30.days
    self.active = 1
    self.anonymous = 1
  end

  def candidatelist=(candlist)
    @raw_candidates = candlist
  end

  def name
    read_attribute( :name ).downcase()
  end

  def reviewed?
    reviewed.to_i == 1
  end

  def create_candidates
    @raw_candidates.each do |name|
      candidate = Candidate.new({:name => name})
      self.candidates << candidate
    end
  end
end
